#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsCClientLib.py,v 1.2 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  11/06/2001  Created


# Small jacket module to make it possible to view the header file for
# the NG/AMS C-API Library.

from ngams import *


def _ngamsGenDocPage(cSrcFile):
    """
    Parse in a C source file code and generate an ASCII man-page from
    comments in the doc++ format.

    cSrcFile:     C source file.

    Returns:      Man-page string buffer.
    """
    fo = open(libSrcFile)

    srcFileLines = fo.readlines()

    docDic   = {}
    docCount = 0
    lineIdx  = 0
    while lineIdx < len(srcFileLines):
        line = srcFileLines[lineIdx]
        if (line.find("/**") != -1):
            # Get the documentation text. Read until */ encountered.
            lineIdx += 1
            docText = ""
            while lineIdx < len(srcFileLines):
                line = srcFileLines[lineIdx]
                if (line.find("*/") != -1):
                    break
                else:
                    docText += line
                lineIdx += 1
            docDic[docCount] = docText
            docCount += 1   
        lineIdx += 1

    docPage = ""
    for docIdx in range(len(docDic.keys())):
        docPage += docDic[docIdx] + "\n\n"

    return docPage

libSrcFile = ngamsGetSrcDir() + "/ngamsCClient/ngamsCClientLib.c"
__doc__ = _ngamsGenDocPage(libSrcFile)


# EOF
