#******************************************************************************
# ESO/DMD
#
# "@(#) $Id: ngams3wareDiskSyncPlugIn.py,v 1.6 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  10/05/2001  Created.
#

"""
Module that contains a Disk Dync Plug-In for the 3ware Controller.
"""

from   ngams import *
import ngamsPlugInApi


def ngams3wareDiskSyncPlugIn(srvObj):
    """
    Disk Sync Plug-In to flush the cache of the 3ware controller.

    srvObj:        Reference to instance of NG/AMS Server class (ngamsServer).

    Returns:       Void.
    """
    info(4,"Entering ngams3wareDiskSyncPlugIn() ...")

    # Sync filesystem to ensure file received on disk.
    # IMPL: Set log levels to 4 when 'sync problem' has been solved.
    info(3,"Performing OS sync command ...")
    commands.getstatusoutput("sync")
    info(3,"Performed OS sync command")
    logFlush()   # IMPL: Remove this line when 'sync problem' solved.

    info(4,"Leaving ngams3wareDiskSyncPlugIn()")


if __name__ == '__main__':
    """
    Main function.
    """
    pass


# EOF
