#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsTestWakeUpPlugIn.py,v 1.9 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  23/01/2002  Created
#

"""
Test WakeUp Plug-In to simulate the NGAS host suspension.

This must be used together with the ngamsTestSuspensionPlugIn.
"""

# IMPL: Move this module to ngams/ngamsTest!

from   ngams import *


def ngamsTestWakeUpPlugIn(srvObj,
                          hostId):
    """
    Dummy Wake-Up Plug-In to test the handling of the NGAS host suspension.

    srvObj:         Reference to instance of the NG/AMS Server (ngamsServer).

    hostId:         Name of NGAS host to be woken up (string).
 
    Returns:        Void.
    """
    info(2,"Test Wake-Up Plug-In executing ...")
    info(2,"Waking up host with ID: %s ..." % hostId)
    info(3,"Resetting the Wake-Up Call Parameters set by the other " +\
         "process ...")
    srvObj.getDb().resetWakeUpCall(hostId, 1)
    info(3,"Wake-Up Call Parameters set by the other process reset")
    info(2,"Leaving Test Wake-Up Plug-In")


# EOF
