#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsConfigCmd.py,v 1.13 2005/08/11 10:23:09 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  04/04/2002  Created
#

"""
Contains code for handling the CONFIG command.
"""

import pcc, PccUtTime
from ngams import *
import ngamsLib


def handleCmdConfig(srvObj,
                    reqPropsObj,
                    httpRef):
    """
    Handle CONFIG command.
        
    srvObj:         Reference to NG/AMS server class object (ngamsServer).
    
    reqPropsObj:    Request Property object to keep track of actions done
                    during the request handling (ngamsReqProps).
        
    httpRef:        Reference to the HTTP request handler
                    object (ngamsHttpRequestHandler).
        
    Returns:        Void.
    """
    info(4,"Entering handleCmdConfig() ...")
    logSysLog        = None
    logSysLogPrefix  = None
    logLocalLogFile  = None
    logLocalLogLevel = None
    logVerboseLevel  = None
    logBufferSize    = None
    for httpPar in reqPropsObj.getHttpParNames():
        if (httpPar == "log_sys_Log"):
            logSysLog = reqPropsObj.getHttpPar("log_sys_Log")
        elif (httpPar == "log_sys_log_prefix"):
            logSysLogPrefix = reqPropsObj.getHttpPar("log_sys_log_prefix")
        elif (httpPar == "log_local_log_file"):
            logLocalLogFile = reqPropsObj.getHttpPar("log_local_log_file")
        elif (httpPar == "log_local_log_level"):
            logLocalLogLevel = reqPropsObj.getHttpPar("log_local_log_level")
        elif (httpPar == "log_verbose_level"):
            logVerboseLevel = reqPropsObj.getHttpPar("log_verbose_level")
        elif (httpPar == "log_buffer_size"):
            logBufferSize = reqPropsObj.getHttpPar("log_buffer_size")
        else:
            pass

    # Handle the configuration change.
    if ((logSysLog != None) or (logSysLogPrefix != None) or
        (logLocalLogFile != None) or (logLocalLogLevel != None) or
        (logVerboseLevel != None)):
        setLogCond(logSysLog, logSysLogPrefix, logLocalLogLevel,
                   logLocalLogFile, logVerboseLevel)
    if (logBufferSize != None):
        setLogCache(int(logBufferSize))

    srvObj.reply(reqPropsObj.setCompletionTime(), httpRef, NGAMS_HTTP_SUCCESS,
                 NGAMS_SUCCESS, "Handled CONFIG command")
    srvObj.updateRequestDb(reqPropsObj)
    info(4,"Leaving handleCmdConfig()")


# EOF
