#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsExitCmd.py,v 1.4 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  13/05/2003  Created
#

"""
Function + code to handle the EXIT command.
"""

from ngams import *
import ngamsSrvUtils


def handleCmdExit(srvObj,
                  reqPropsObj,
                  httpRef):
    """
    Handle an EXIT command.
        
    reqPropsObj:    Request Property object to keep track of actions done
                    during the request handling (ngamsReqProps).
        
    httpRef:        Reference to the HTTP request handler object
                    (ngamsHttpRequestHandler).
        
    Returns:        Void.   
    """
    srvObj.checkSetState("Command EXIT", [NGAMS_OFFLINE_STATE],
                         [NGAMS_IDLE_SUBSTATE])
    srvObj.reply(reqPropsObj.setCompletionTime(), httpRef, NGAMS_HTTP_SUCCESS,
                 NGAMS_SUCCESS, "NG/AMS Server performing exit ...")
    srvObj.updateRequestDb(reqPropsObj)
    ngamsSrvUtils.ngamsBaseExitHandler(srvObj, 0, 1)    


# EOF
