#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsHelpCmd.py,v 1.14 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  04/04/2002  Created
#

"""
Contains code for handling the HELP command.

IMPL: The HELP command is not yet implemented!
"""

import pydoc
import pcc, PccUtTime
from ngams import *
import ngamsLib, ngamsStatus


def handleCmdHelp(srvObj,
                  reqPropsObj,
                  httpRef):
    """
    Handle HELP command.
        
    srvObj:         Reference to NG/AMS server class object (ngamsServer).
    
    reqPropsObj:    Request Property object to keep track of actions done
                    during the request handling (ngamsReqProps).
        
    httpRef:        Reference to the HTTP request handler
                    object (ngamsHttpRequestHandler).
        
    Returns:        Void.
    """
    info(4,"Entering handleCmdHelp() ...")

    ##########################################################################
    # COMMAND NOT YET IMPLEMENTED - REMOVE THIS BLOCK WHEN IMPLEMENTED
    ##########################################################################
    status = ngamsStatus.ngamsStatus()
    status.\
             setDate(PccUtTime.TimeStamp().getTimeStamp()).\
             setVersion(getNgamsVersion()).\
             setHostId(getHostId()).setStatus(NGAMS_FAILURE).\
             setMessage("Command HELP not implemented").\
             setState(srvObj.getState()).setSubState(srvObj.getSubState())
    msg = status.genXmlDoc()
    srvObj.httpReplyGen(reqPropsObj.setCompletionTime(), httpRef,
                        NGAMS_HTTP_SUCCESS, msg)
    srvObj.updateRequestDb(reqPropsObj)
    info(4,"Leaving handleCmdHelp()")
    return
    ##########################################################################

    # Get the information requested.
    msg = ""
    doc = ""
    if (reqPropsObj.hasHttpPar("doc")):
        doc = reqPropsObj.getHttpPar("doc")
        if (doc == ""):
            msg = pydoc.HTMLDoc().index(NGAMS_SRC_DIR + "/..")
        elif (os.path.isdir("doc")):
            msg = pydoc.HTMLDoc().index(doc)
        elif (doc.find(".py") != -1):
            msg = pydoc.HTMLDoc().docmodule(NGAMS_SRC_DIR + "/" + doc)
        else:
            pass
    else:
        status = ngamsStatus.ngamsStatus()
        status.\
                 setDate(PccUtTime.TimeStamp().getTimeStamp()).\
                 setVersion(getNgamsVersion()).\
                 setHostId(getHostId()).setStatus(NGAMS_SUCCESS).\
                 setMessage("Successfully handled command HELP").\
                 setState(srvObj.getState()).setSubState(srvObj.getSubState())
        msg = status.genXmlDoc()
        
    srvObj.httpReplyGen(reqPropsObj.setCompletionTime(), httpRef,
                        NGAMS_HTTP_SUCCESS, msg)
    srvObj.updateRequestDb(reqPropsObj)
    info(4,"Leaving handleCmdHelp()")


# EOF
