#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsInitCmd.py,v 1.5 2004/08/04 16:45:30 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  13/05/2003  Created
#

"""
Function + code to handle the INIT command.
"""

from ngams import *
import ngamsSrvUtils


def handleCmdInit(srvObj,
                  reqPropsObj,
                  httpRef):
    """
    Handle an INIT command.
        
    srvObj:         Reference to NG/AMS server class object (ngamsServer).
    
    reqPropsObj:    Request Property object to keep track of actions done
                    during the request handling (ngamsReqProps).
        
    httpRef:        Reference to the HTTP request handler
                    object (ngamsHttpRequestHandler).
        
    Returns:        Void.   
    """
    srvObj.checkSetState("Command INIT", [NGAMS_ONLINE_STATE],
                         [NGAMS_IDLE_SUBSTATE])
    info(1,"Handling INIT command - re-initializing NG/AMS ...")
    ngamsSrvUtils.handleOffline(srvObj, reqPropsObj)
    ngamsSrvUtils.handleOnline(srvObj, reqPropsObj)
    info(1,"NG/AMS initialized!")
    srvObj.reply(reqPropsObj.setCompletionTime(), httpRef, NGAMS_HTTP_SUCCESS,
                 NGAMS_SUCCESS, "Successfully handled command INIT")
    srvObj.updateRequestDb(reqPropsObj)
    info(1,"Successfully handled command INIT!")


# EOF
