#******************************************************************************
# ESO/DFS
#
# "@(#) $Id: ngamsTestPstats.py,v 1.3 2004/08/04 16:45:31 ngasmgr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  23/04/2002  Created
#

"""
This module contains a utility class for doing profiling on the NG/AMS
Unit Tests.
"""

import pstats


class ngamsTestPstats(pstats.Stats):
    """
    NG/AMS inherited profiling report generator.
    """
    
    def __init__(self,
                 *args):
        """
        Constructor method.

        args:   Tuple with filenames used to build the report (tuple)
        """
        pstats.Stats.__init__(self, args)

       
    def get_print_list(self,
                       sel_list):
        """
        """
        width = self.max_name_len
        if self.fcn_list:
            list = self.fcn_list[:]
            msg = "   Ordered by: " + self.sort_type + '\n'
        else:
            list = self.stats.keys()
            msg = "   Random listing order was used\n"

        for selection in sel_list:
            list,msg = self.eval_print_amount(selection, list, msg)

        count = len(list)

        if not list:
            return 0, list
        if count < len(self.stats):
            width = 0
            for func in list:
                if  len(func_std_string(func)) > width:
                    width = len(func_std_string(func))
        return width+2, list
        

# EOF
