#!/usr/bin/python
#******************************************************************************
# ESO/DMD
#
# "@(#) $Id: vultur_display_cascade.py,v 1.1.1.1 2005/12/08 16:38:31 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  01/04/2005  Created
#

import sys, os, time, commands


def correctUsage():
    """
    """
    print "\nCorrect usage is:\n\n" +\
          "vultur_exec_cascade -jobId <ID> " +\
          "-job \"<ID>||<App>||<Args>\" [-job \"<ID>||<App>||<Args>\"] " +\
          "[-cascade ((<Job ID>[,<Job ID>]: <Job ID>[,<Job ID>]), ...)]\n\n"+\
          "Note, <Job ID> should be set to NONE if the job is not depending "+\
          "on any parent job.\n\n"


def submitDag(argv):
    """
    """
    jobId = cascade = None
    jobList = []
    idx = 1
    while idx < len(sys.argv):
        par = sys.argv[idx].upper()
        if (par == "-JOBID"):
            idx += 1
            jobId = sys.argv[idx]
        elif (par == "-JOB"):
            idx += 1
            job.append(sys.argv[idx])
        elif (par == "-CASCADE"):
            idx += 1
            cascade = sys.argv[idx]
        elif ((par == "-H") or (par == "-HELP")):
            correctUsage()
            sys.exit(0)
        else:
            correctUsage()
            sys.exit(1)
        idx += 1
    
    if ((not jobId) or (not dag)):
        correctUsage()
        sys.exit(1)

    # Generate Job Submission Files.
    jobSubmisName = JOB_SUBMIS_FILE % (user, jobId)
    jobSubmis = JOB_SUBM_FORM % (application,
                                 user, jobId,
                                 user, jobId,
                                 user, jobId,
                                 args, user,
                                 noOfJobs)
    os.system("rm -f %s" % jobSubmisName)
    fo = open(jobSubmisName, "w")
    fo.write(jobSubmis)
    fo.close()

    


    # Execute DAG.
    submitCmd = CONDOR_JOB_SUBMIT % jobSubmisName
    stat, out = commands.getstatusoutput(submitCmd)


if __name__ == '__main__':
    """
    Main function.
    """
    submitDag(sys.argv)
    sys.exit(0)

# EOF
