#!/usr/bin/python
#******************************************************************************
# ESO/DMD
#
# "@(#) $Id: vultur_exec_esorex.py,v 1.1.1.1 2005/12/08 16:38:31 jknudstr Exp $"
#
# Who       When        What
# --------  ----------  -------------------------------------------------------
# jknudstr  01/04/2005  Created
#

import sys, os, time, commands

# Example command line to launch ESOREX:
#
# --recipe-dir=/home/rei/raid/instroot/lib/ --output-dir=/home/rei/raid/data/wfi/products/ --output-prefix=mbias_ext8 ocam_mbias /home/rei/raid/data/condor/ocam-demo/sof/BiasFramesWFI_EXT8.sof

# The Installation Root under which all the needed SW is found:
INST_ROOT = "/shared/system/i86/RH9.0/instroot"


def correctUsage():
    """
    """
    print "\nCorrect usage is:\n\n" +\
          "vultur_exec_esorex -prefix <Prefix> -recipe <Recipe> -sof <SOF> "+\
          "-user <User> [-instRoot <Installation Root>]\n\n"
    

def invokeEsorex(argv):
    """
    """
    prefix = recipe = sof = user = None
    instRoot = INST_ROOT
    idx = 1
    while idx < len(sys.argv):
        par = sys.argv[idx].upper()
        if (par == "-PREFIX"):
            idx += 1
            prefix = sys.argv[idx]
        elif (par == "-RECIPE"):
            idx += 1
            recipe = sys.argv[idx]
        elif (par == "-SOF"):
            idx += 1
            sof = sys.argv[idx]
        elif (par == "-USER"):
            idx += 1
            user = sys.argv[idx]
        elif (par == "-INSTROOT"):
            idx += 1
            instRoot = sys.argv[idx]
        elif ((par == "-H") or (par == "-HELP")):
            correctUsage()
            sys.exit(0)
        else:
            correctUsage()
            sys.exit(1)
        idx += 1
    
    if ((not prefix) or (not recipe) or (not sof) or (not user)):
        correctUsage()
        sys.exit(1)
    
    # Execute esorex.
    soDirs   = "%s/lib:%s/plugins" % (instRoot, instRoot)
    recDir   = instRoot + "/plugins"
    prodDir  = "/shared/data/%s/products" % user
    tmpProdDir = "%s/tmp" % prodDir
    esoRexCmdFormat = "cd %%s; export LD_LIBRARY_PATH=%s; %s/bin/esorex " +\
                      "--recipe-dir=%s/ --output-dir=%s/ " +\
                      "--suppress-prefix=TRUE " +\
                      "--output-prefix=%%s %%s %%s"
    esoRexCmdFormat = esoRexCmdFormat % (soDirs, instRoot, recDir, prodDir)
    tmpDir = "%s/%s_%.5f" % (tmpProdDir, prefix, time.time()) 
    try:
        commands.getstatusoutput("mkdir -p %s" % tmpDir)
        esoRexCmd = esoRexCmdFormat % (tmpDir, prefix, recipe, sof)
        print "Invoking esorex: %s" % esoRexCmd
        stat, out = commands.getstatusoutput(esoRexCmd)
        if (stat != 0):
            sys.stderr.write(out)
            sys.exit(1)
        else:
            print out
    except Exception, e:
        os.system("rm -rf %s" % tmpDir)
        sys.stderr.write("Problem occurred executing esorex: %s\n" % str(e))
        sys.exit(1)
    os.system("rm -rf %s" % tmpDir)

    
if __name__ == '__main__':
    """
    Main function.
    """
    invokeEsorex(sys.argv)
    sys.exit(0)

# EOF
